package com.grapeshot.halfnes;
//HalfNES, Copyright Andrew Hoffman, October 2010

import com.grapeshot.halfnes.mappers.BadMapperException;
import com.grapeshot.halfnes.mappers.Mapper;
import java.io.*;

public class ROMLoader {
    //this is the oldest code in the project... I'm honestly ashamed
    //at how it's structured but for now it works.
    //TODO: fix this up

    public File path;
    public int prgsize;
    public int chrsize;
    public Mapper.MirrorType scrolltype;
    public int mappertype;
    public int prgoff;
    public int chroff;
    public boolean savesram = false;

    public ROMLoader() {
        path = new File(
                "C:\\Users\\Andrew\\Downloads\\v\\NES\\ROM\\Balloon Fight.nes");
    }

    public ROMLoader(File file) {
        path = file;
        if (!path.exists()) {
            try {
                throw new IOException("ROM does not exist");
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }

    public static int[] bytesToInts(byte[] bytes) {
        int[] ints = new int[bytes.length];
        for (int i = 0; i < bytes.length; i++) {
            ints[i] = (bytes[i] & 0xFF);
        }
        return ints;
    }

    public static int[] bytesFromFile(File file) {
        byte[] bytes = new byte[(int) file.length()];
        FileInputStream fis;
        try {
            fis = new FileInputStream(file);

            try {
                fis.read(bytes);
                fis.close();
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            }
        return bytesToInts(bytes);
    }

    public int[] ReadHeader(int len) {
        // iNES header is 16 bytes, nsf header is 128
        try {
            return load(len, -16);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return new int[len];
    }

    public void parseNSFHeader() throws BadMapperException, IOException {
    }

    public void parseInesheader() throws BadMapperException, IOException {
        int[] inesheader = ReadHeader(16);
        // decode iNES 1.0 headers
        // 1st 4 bytes : $4E $45 $53 $1A
        if (inesheader[0] != 0x4E || inesheader[1] != 0x45
                || inesheader[2] != 0x53 || inesheader[3] != 0x1A) {
            // not a valid file
            if (inesheader[0] == 'U') {
                throw new IOException("This is a UNIF file with the wrong extension");
            }
            throw new IOException("iNES Header Invalid");

        }
        prgsize = 16384 * inesheader[4];
        chrsize = 8192 * inesheader[5];
        scrolltype = utils.getbit(inesheader[6], 3) ? Mapper.MirrorType.FOUR_SCREEN_MIRROR : (utils.getbit(inesheader[6], 0) ? Mapper.MirrorType.V_MIRROR : Mapper.MirrorType.H_MIRROR);
        savesram = utils.getbit(inesheader[6], 1);
        //TODO: 4-screen and single screen
        mappertype = (inesheader[6] >> 4);


        if (inesheader[11] + inesheader[12] + inesheader[13] + inesheader[14]
                + inesheader[15] == 0) {// fix for DiskDude
            mappertype += ((inesheader[7] >> 4) << 4);
        }

        // calc offsets; header not incl. here
        prgoff = 0;
        chroff = 0 + prgsize;
    }

    public int[] load(int size, int offset) throws IOException {
        int[] bindata = new int[size];
        int[] loaded = bytesFromFile(path);
        for (int i = 0; i < size; ++i) {
            bindata[i] = loaded[i + offset + 16];
        }
        return bindata;
    }
}
